// Copyright 2022 hjiayz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
use regexp2rust_macro::regex2rust;
#[test] 
fn run(){
    regex2rust!( foo = "12345(?<abc>123)" "ui");
    assert_eq!(foo::exec(" 12345123"),[Some([1,9]),Some([6,9])]);
    assert_eq!(foo::Group::abc as usize,1usize);
    assert_eq!(foo::exec(" 12345123")[foo::Group::abc as usize],Some([6,9]));
    assert_eq!(foo::matches(" 12345123"),["12345123","123"]);
} 

#[test]
fn testend(){
    regex2rust!( foo = "$" "ui");
    assert_eq!(foo::exec(""),[Some([0,0])]);
}
 
#[test]
fn global(){
    regex2rust!( foo = "1" "uig");
    assert_eq!(foo::exec("111",1),[Some([1,2])]);
    let x : Vec<[usize;2]> =  foo::Iter::new("111",0).collect();
    assert_eq!(x,[[0,1],[1,2],[2,3]]);
}

#[test]
fn sticky(){
    regex2rust!( foo = "1" "uiy");
    assert_eq!(foo::exec(" 111",1),[Some([1,2])]);
    assert_eq!(foo::exec(" 111",0),[None]);
    assert_eq!(foo::matches(" 111",0),[""]);
}


#[test]
fn globalsticky(){
    regex2rust!( foo = "1" "uigy");
    let x : Vec<[usize;2]> =  foo::Iter::new("11 1",0).collect();
    assert_eq!(x,[[0,1],[1,2]]);
}